- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.Rollout.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.Rollout.SCHEMA_REPRESENTATION.rollout_entity.SCHEMA_REPRESENTATION)
    - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.Rollout.SCHEMA_REPRESENTATION.wave_details.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#body.aspect)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/v1/rollouts/get#try-it)

Gets details of a single project-scoped Rollout.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/v1/projects/{project}/global/rollouts/{rollout}`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `rollout` | `string` Name of the persistent rollout to return. |

### Request body

The request body must be empty.

### Response body

Rollout resource.

A Rollout is a specific instance of a RolloutPlan. It represents a single execution of a strategy to roll out a specific resource. It also provides APIs to interact with the rollout.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "selfLink": string, "selfLinkWithId": string, "rolloutEntity": { "orchestratedEntity": { "orchestrationAction": string, "orchestrationSource": string, "conflictBehavior": string } }, "rolloutPlan": string, "state": enum, "etag": string, "currentWaveNumber": string, "waveDetails": [ { "orchestratedWaveDetails": { "estimatedTotalResourcesCount": string, "completedResourcesCount": string, "failedResourcesCount": string, "failedLocations": [ string ], "locationStatus": { string: { "state": enum }, ... }, "estimatedCompletionTime": string }, "waveDisplayName": string, "waveNumber": string } ], "completionTime": string, "cancellationTime": string, "pauseTime": string, "resumeTime": string } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#rollout` for rollouts. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource. This identifier is defined by the server. |
| `creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `name` | `string` Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `description` | `string` An optional description of this resource. Provide this property when you create the resource. |
| `selfLink` | `string` Output only. Server-defined fully-qualified URL for this resource. |
| `selfLinkWithId` | `string` Output only. Server-defined URL for this resource's resource id. |
| `rolloutEntity` | `object` Required. The resource being rolled out. |
| `rolloutEntity.orchestratedEntity` | `object` Optional. Entity details for products using the Orchestrated Integration model. |
| `rolloutEntity.orchestratedEntity.orchestrationAction` | `string` Required. Orchestration action during the Rollout. It can be one of the following values: 1) "update": Resources will be updated by the rollout. 2) "delete": Resources will be deleted by the rollout. |
| `rolloutEntity.orchestratedEntity.orchestrationSource` | `string` Required. Fully qualified resource name of the resource which contains the source of truth of the configuration being rolled out across locations/projects. For example, in the case of a global Rollout which is applied across regions, this contains the name of the global resource created by the user which contains a payload for a resource that is orchestrated across regions. This follows the following format: //.googleapis.com/projects//locations/global// e.g. //osconfig.googleapis.com/projects/1/locations/global/policyOrchestrators/po1 |
| `rolloutEntity.orchestratedEntity.conflictBehavior` | `string` Required. Specifies the behavior of the Rollout if an out of band update is detected in a project during a Rollout. It can be one of the following values: 1) overwrite : Overwrite the local value with the rollout value. 2) no_overwrite : Do not overwrite the local value with the rollout value. |
| `rolloutPlan` | `string` Required. Rollout Plan used to model the Rollout. Ex. compute.googleapis.com/v1/projects/1234/rolloutPlans/rp1 |
| `state` | `enum` Output only. The current state of the Rollout. |
| `etag` | `string` Output only. etag of the Rollout Ex. abc1234 |
| `currentWaveNumber` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The number of the currently running wave. Ex. 1 |
| `waveDetails[]` | `object` Output only. Details about each wave of the rollout. |
| `waveDetails[].orchestratedWaveDetails` | `object` Output only. Additional details of the wave for products using the Orchestrated Integration model. |
| `waveDetails[].orchestratedWaveDetails.estimatedTotalResourcesCount` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Estimated total count of resources. |
| `waveDetails[].orchestratedWaveDetails.completedResourcesCount` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Resource completed so far. |
| `waveDetails[].orchestratedWaveDetails.failedResourcesCount` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. Resources failed. |
| `waveDetails[].orchestratedWaveDetails.failedLocations[]` | `string` Output only. Locations that failed during orchestration, and ProgressiveRollout stopped retrying. There may be some successful resources rolled out in the wave as the location may have failed later in the Rollout. |
| `waveDetails[].orchestratedWaveDetails.locationStatus[]` | `map (key: string, value: object)` Output only. Status of each location in the wave. Map keys (locations) must be specified like "us-east1" or "asia-west1-a". |
| `waveDetails[].orchestratedWaveDetails.locationStatus[].state` | `enum` Output only. Location state of the wave. |
| `waveDetails[].orchestratedWaveDetails.estimatedCompletionTime` | `string` Output only. Estimated timestamp at which the wave will complete. Extrapolated from current progress. |
| `waveDetails[].waveDisplayName` | `string` Output only. Wave name. Ex. wave1 |
| `waveDetails[].waveNumber` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. System generated number for the wave. |
| `completionTime` | `string` Output only. The timestamp at which the Rollout was completed. |
| `cancellationTime` | `string` Output only. The timestamp at which the Rollout was cancelled. |
| `pauseTime` | `string` Output only. The timestamp at which the Rollout was paused. |
| `resumeTime` | `string` Output only. The timestamp at which the Rollout was resumed. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).